# -*- coding:Utf-8 -*-
# hud_hp V1.212p (05/02/2009) by DoCky


import es, os, psyco, langlib, playerlib, gamethread
psyco.full()

hh_info = es.AddonInfo()
hh_info.version = "1.212p"
hh_info.author = "DoCky"
hh_info.name = "hud_hp"

time = es.ServerVar("hh_time", "", "time (secondes) after round beginning menu is showed")
team = es.ServerVar("hh_team", "", "player team that will receive hud menu")
vers = es.ServerVar(hh_info.name, hh_info.version, "by DoCky -")
vers.set(hh_info.version)
vers.makepublic()


class Langage(object):
    def __init__(self):
        self.lang = langlib.Strings("%s/language.ini" % es.getAddonPath("hud_hp"))

    def exists(self, string):
        if self.lang.has_key(string): return True
        else: return False

    def getLang(self, userid):
        try: lang = langlib.getLangAbbreviation(es.createplayerlist(userid)[userid]["language"])
        except KeyError: lang = langlib.getDefaultLang()
        finally: return lang

    def getText(self, string, userid, keyword = {}):
        if len(keyword): return self.lang(string, opts = keyword, lang = self.getLang(userid))
        else: return self.lang(string, lang = self.getLang(userid))

class MenuHud(object):
    def __init__(self):
        if not int(team): self.team, self.tags = "23", "#human,#alive"
        elif int(team) == 1: self.team, self.tags = "2", "#human,#alive,#t"
        elif int(team) == 2: self.team, self.tags = "3", "#human,#alive,#ct"
        self.loop()

    def loop(self):
        try: self.send(playerlib.getUseridList(self.tags), True)
        except: pass

    def send(self, players, loop = False):
        for userid in players:
            es.usermsg("create", "hh_send", "HintText")
            es.usermsg("write", "byte", "hh_send", "1")
            es.usermsg("write", "string", "hh_send", langage.getText("hud hp", userid, {"healthpoint" : es.getplayerprop(userid, "CBasePlayer.m_iHealth")}))
            es.usermsg("send", "hh_send", userid, "0")
            es.usermsg("delete", "hh_send")
        if loop: gamethread.delayedname(5, "hud_hp", self.loop)

    def hide(self, userid):
        es.usermsg("create", "hh_hide", "ResetHUD")
        es.usermsg("write", "byte", "hh_hide", -1)
        es.usermsg("send", "hh_hide", userid, 1)
        es.usermsg("delete", "hh_hide")


def init():
    global langage, menuhud
    es.server.cmd("es_xmexec ../addons/eventscripts/hud_hp/config.cfg")
    langage, menuhud = Langage(), MenuHud()

def es_map_start(event_var):
    init()

def load():
    init()

def unload():
    try: gamethread.cancelDelayed("hud_hp")
    except: pass

def round_end(ev):
    try: gamethread.cancelDelayed("hud_hp")
    except: pass

def round_start(ev):
    if int(time) <= 0: menuhud.loop()
    else: gamethread.delayed(int(time), menuhud.loop)

def player_hurt(ev):
    if ev["es_userteam"] in menuhud.team:
        if not es.getplayerprop(ev["userid"], "CBasePlayer.pl.deadflag"): menuhud.send((ev["userid"],))
        else: menuhud.hide(ev["userid"])

